'From Cuis 2.4 of 17 June 2010 [latest update: #509] on 3 August 2010 at 8:59:20 am'!

!ChangeSorter class methodsFor: 'removing' stamp: 'jmv 8/3/2010 08:55'!
removeEmptyUnnamedChangeSets
	"Remove all change sets that are empty, whose names start with Unnamed,
		and which are not nailed down by belonging to a Project."
	"ChangeSorter removeEmptyUnnamedChangeSets"
	| toGo |
	(toGo _ (self changeSetsNamedSuchThat: [:csName | csName beginsWith: 'Unnamed'])
		select: [:cs | cs isEmpty and: [cs okayToRemoveInforming: false]])
		do: [:cs | self removeChangeSet: cs].
	self inform: toGo size printString, ' change set(s) removed.'! !


!Utilities class methodsFor: 'common requests' stamp: 'jmv 8/3/2010 08:57'!
initializeCommonRequestStrings
	"Initialize the common request strings, a directly-editable list of expressions that can be evaluated from the 'do...' menu."

	CommonRequestStrings _ StringHolder new contents: 
'Utilities saveScreenshot.
Utilities saveDisplay.
Cursor normal show.
Transcript clear.
-
Undeclared inspect.
Undeclared removeUnreferencedKeys; inspect.
-
ChangeSorter removeEmptyUnnamedChangeSets.
ChangeSorter reorderChangeSets.'

"Utilities initializeCommonRequestStrings"! !

!Utilities class methodsFor: 'common requests' stamp: 'jmv 8/3/2010 08:52'!
saveDisplay
	"Save Display to a file"

	"SampledSound playSoundNamed: 'camera'."
	PNGReadWriter
		putForm: Display
		onFileNamed:
			(FileDirectory default
				nextNameFor: 'SqueakDisplay'
				extension: 'png')! !

!Utilities class methodsFor: 'common requests' stamp: 'jmv 8/3/2010 08:51'!
saveScreenshot
	"Make a screenshot of the world and save it to a file"

	"SampledSound playSoundNamed: 'camera'."
	PNGReadWriter
		putForm: World imageForm
		onFileNamed:
			(FileDirectory default
				nextNameFor: 'SqueakScreen'
				extension: 'png')! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."
Utilities initializeCommonRequestStrings!

