'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 10 November 2010 at 1:42:36 pm'!

!Clipboard methodsFor: 'accessing' stamp: 'jmv 11/10/2010 13:41'!
clipboardText
	"Return the text currently in the clipboard. If the system clipboard is empty, or if it differs from the Smalltalk clipboard text, use the Smalltalk clipboard. This is done since (a) the Mac clipboard gives up on very large chunks of text and (b) since not all platforms support the notion of a clipboard.
	Note:
		Smalltalk clipboard can hold a String or a Text.
		OS clipboard currently supports ony a String"

	| iso8859s15Format primitiveFormat |
	primitiveFormat _ self primitiveClipboardText.
	"The VM uses UTF-8 for clipboard"
	iso8859s15Format _ primitiveFormat utf8ToISO8859s15 withSqueakLineEndings.
	^(iso8859s15Format isEmpty or: [iso8859s15Format = contents asString])
		ifTrue: [ contents ]
		ifFalse: [ iso8859s15Format ]! !

!Clipboard methodsFor: 'accessing' stamp: 'jmv 11/10/2010 13:42'!
clipboardText: textOrString
	"Set text currently on the clipboard.  Also export to OS"
	| primitiveFormat |
	contents _ textOrString.
	self noteRecentClipping: textOrString.
	"The VM uses UTF-8 for clipboard"
	primitiveFormat _ textOrString asString iso8859s15ToUtf8 withLineEndings: String lf.
	self primitiveClipboardText: primitiveFormat! !

