'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 24 December 2010 at 12:02:36 am'!

!ActiveModel methodsFor: 'objects from disk' stamp: 'jmv 12/23/2010 15:13'!
objectForDataStream: refStrm
	"Warning: When serializing to disk, do NOT include dependents.
	(Same is done at Model)"
	^ self shallowCopy
		 releaseActionMap;
		 yourself! !


!Color methodsFor: 'objects from disk' stamp: 'jmv 12/24/2010 00:02'!
objectForDataStream: refStrm

	"I am about to be written on an object file. Clear cached stuff."
	^self shallowCopy flushCache; yourself! !


!Model methodsFor: 'objects from disk' stamp: 'jmv 12/23/2010 15:13'!
objectForDataStream: refStrm
	"Warning: When serializing to disk, do NOT include dependents.
	(Same is done at ActiveModel)"
	^ self shallowCopy
		 myDependents: nil;
		 yourself! !


!StrikeFont methodsFor: 'objects from disk' stamp: 'jmv 12/23/2010 15:33'!
objectForDataStream: refStrm

	"I am about to be written on an object file.  Write a textual reference instead.
	Warning: This saves a lot of space, but might fail if using other fonts than those in AvailableFonts"

	^ DiskProxy
		global: #AbstractFont
		selector: #familyName:aroundPointSize:
		args: (Array with: self familyName with: self pointSize)! !


!TextStyle methodsFor: 'objects from disk' stamp: 'jmv 12/24/2010 00:00'!
objectForDataStream: refStrm

	"I am about to be written on an object file.  Write a textual reference instead.
	Warning: This saves a lot of space, but might fail if using other styles than those in AvailableTextStyles"

	^ DiskProxy
		global: #TextStyle
		selector: #named:
		args: (Array with: self name)! !


!Color reorganize!
('access' alpha blue brightness chroma green hue luminance red saturation)
('equality' = diff: hash)
('queries' isBlack isGray isOpaque isSolidFill isTransparent)
('transformations' * + - / adjustBrightness: adjustSaturation:brightness: alpha: alphaMixed:with: atLeastAsLuminentAs: atMostAsLuminentAs: blacker dansDarker darker duller lighter mixed:with: muchDarker muchLighter negated orColorUnlike: paler quiteBlacker quiteWhiter slightlyDarker slightlyLighter slightlyWhiter twiceDarker twiceLighter veryMuchDarker veryMuchLighter whiter)
('groups of shades' darkShades: lightShades: mix:shades: wheel:)
('printing' printOn: shortPrintString storeArrayOn: storeArrayValuesOn: storeOn:)
('other' display name raisedColor rgbTriplet)
('conversions' asColor asColorref asNontranslucentColor balancedPatternForDepth: bitPatternForDepth: closestPixelValue1 closestPixelValue2 closestPixelValue4 closestPixelValue8 dominantColor halfTonePattern1 halfTonePattern2 indexInMap: makeForegroundColor pixelValue32 pixelValueForDepth: pixelWordFor:filledWith: pixelWordForDepth: scaledPixelValue32)
('private' attemptToMutateError flushCache privateAlpha privateBlue privateGreen privateRGB privateRed setHue:chroma:brightness: setHue:chroma:luminance: setHue:saturation:brightness: setPrivateRed:green:blue: setRGB: setRed:green:blue: setRed:green:blue:range:)
('copying' veryDeepCopyWith:)
('testing' is:)
('objects from disk' objectForDataStream:)
!

