'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 23 April 2011 at 10:39:35 pm'!

!CodeProvider methodsFor: 'message list menu' stamp: 'jmv 11/25/2010 11:36'!
browseClassVarRefs
	"1/17/96 sw: devolve responsibility to the class, so that the code that does the real work can be shared"

	| cls |
	cls _ self selectedClass.
	cls ifNotNil: [cls browseClassVarRefs]! !


!Inspector methodsFor: 'message list menu' stamp: 'jmv 9/21/2009 15:08'!
browseClassVarRefs
	"1/17/96 sw: devolve responsibility to the class, so that the code that does the real work can be shared"

	| cls |
	cls _ self selectedClass.
	cls ifNotNil: [cls browseClassVarRefs]! !


!SystemDictionary methodsFor: 'browsing' stamp: 'jmv 4/23/2011 22:25'!
browseViewReferencesFromNonViews
	"
	Smalltalk browseViewReferencesFromNonViews
	"
	| aList aLiteral aCollection |
	aCollection _ OrderedCollection new.

	"Tweak to look just for pluggables or also for menus (or maybe for all morphs)"
"	PopUpMenu withAllSubclasses , MenuMorph withAllSubclasses , PluggableMorph withAllSubclasses do: [ :view |"
	PluggableMorph withAllSubclassesDo: [ :view |
"	MenuMorph withAllSubclassesDo: [ :view |"
		
		aLiteral _ view name.
		
		"tweak to linclude refs to SysWindow subhierarchy or not"
		(view includesBehavior: SystemWindow) 
		& false
		ifFalse: [
		
			Smalltalk allBehaviorsDo: [ :class |
				((class includesBehavior: Morph) or: [ class includesBehavior: Morph class ]) ifFalse: [
					aList _ class
						whichSelectorsReferTo: aLiteral
						special: false
						byte: nil.
					aList do: [ :sel |
						sel == #DoIt ifFalse: [
							"For special selectors, look for the literal in the source code.
							Otherwise, for example, searching for senders of #== will include senders of #ifNil:"
							((class sourceCodeAt: sel) findString: aLiteral) > 0  ifTrue: [
								aCollection add:
									(MethodReference new
										setStandardClass: class
										methodSymbol: sel) ]]]]]]].
	Smalltalk
		browseMessageList: aCollection asSet asArray sort
		name: 'References to Views from non-Views'
		autoSelect: ''.! !


!SystemWindow methodsFor: 'initialization' stamp: 'jmv 4/23/2011 22:31'!
createCloseBox
	^(PluggableButtonMorph model: self action: #closeBoxHit)
		extent: self boxExtent;
		icon: self class closeIcon;
		setBalloonText: 'close this window'! !

!SystemWindow methodsFor: 'initialization' stamp: 'jmv 4/23/2011 22:31'!
createCollapseBox
	^(PluggableButtonMorph model: self action: #collapseOrExpand)
		extent: self boxExtent;
		icon: self class collapseIcon;
		setBalloonText: 'collapse this window'! !

!SystemWindow methodsFor: 'initialization' stamp: 'jmv 4/23/2011 22:31'!
createExpandBox
	^(PluggableButtonMorph model: self action: #expandBoxHit)
		extent: self boxExtent;
		icon: self class expandIcon;
		setBalloonText: 'expand to full screen'! !

!SystemWindow methodsFor: 'initialization' stamp: 'jmv 4/23/2011 22:31'!
createMenuBox
	^(PluggableButtonMorph model: self action: #offerWindowMenu)
		extent: self boxExtent;
		icon: self class menuIcon;
		setBalloonText: 'window menu'! !


!InspectorWindow methodsFor: 'GUI building' stamp: 'jmv 4/23/2011 22:07'!
buildMorphicWindow
	" Inspector openAsMorphOn: SystemOrganization "
	| contentsText list upperRow evaluatorText |
	self flag: #ojo.	"buscar doubleClickSelector: #, porque esto es lo que me abre inspectors locos al double click trucho (no intencional)"
	list _ PluggableListMorph new
			doubleClickSelector: #inspectSelection;
			model: model 
			listGetter: #fieldList
			indexGetter: #selectionIndex
			indexSetter: #toggleIndex:
			menuGetter: (MessageSend receiver: self selector: #fieldListMenu)
			keystrokeAction: #inspectorKey:from:.
	contentsText _ TextModelMorph
			textProvider: model
			textGetter: #acceptedContents 
			textSetter: #accept:
			selectionGetter: #contentsSelection.
	evaluatorText _ (TextModelMorph textProvider: model)
			askBeforeDiscardingEdits: false.
	upperRow _ LayoutMorph newRow.
	upperRow
		addMorph: list proportionalWidth: 0.3;
		addAdjusterAndMorph: contentsText proportionalWidth: 0.7.
	self layoutMorph
		addMorph: upperRow proportionalHeight: 0.7;
		addAdjusterAndMorph: evaluatorText proportionalHeight: 0.3.
	self setLabel: model object defaultLabelForInspector.
	self setUpdatablePanesFrom: #(fieldList)! !

ClassCommentVersionsBrowser removeSelector: #versionsMenu!
VersionsBrowser removeSelector: #findOriginalChangeSet!
VersionsBrowser removeSelector: #versionsMenu!
TestRunner removeSelector: #browse:!
TestRunner removeSelector: #listMenu!
ChangeSorterWindow removeSelector: #browseMethodConflictsWithOtherSide!
RecentMessageSet removeSelector: #addExtraShiftedItemsTo:!
RecentMessageSet removeSelector: #messageListMenu!
RecentMessageSet removeSelector: #setRecentHistorySize!
ProcessBrowser removeSelector: #processListMenu!
ProcessBrowser removeSelector: #stackListMenu!
ObjectExplorer removeSelector: #exploreObjectPointers!
ObjectExplorer removeSelector: #genericMenu!
ObjectExplorer removeSelector: #inspectBasic!
MessageNames removeSelector: #selectorListMenu!
MessageSet removeSelector: #addExtraShiftedItemsTo:!
MessageSet removeSelector: #filterMessageList!
DictionaryInspector removeSelector: #addEntry!
DictionaryInspector removeSelector: #renameEntry!
DictionaryInspector removeSelector: #sendersOfSelectedKey!
Inspector removeSelector: #browseProtocol!
Inspector removeSelector: #exploreObjectPointers!
Inspector removeSelector: #fieldListMenu!
Inspector removeSelector: #inspectBasic!
FileList removeSelector: #fileListMenu!
FileList removeSelector: #fileSelectedMenu!
FileList removeSelector: #noFileSelectedMenu!
FileContentsBrowser removeSelector: #browseSenders!
FileContentsBrowser removeSelector: #classListMenu!
FileContentsBrowser removeSelector: #messageCategoryMenu!
FileContentsBrowser removeSelector: #messageListMenu!
FileContentsBrowser removeSelector: #packageListMenu!
FileContentsBrowser removeSelector: #shiftedClassListMenu!
Debugger removeSelector: #contextStackMenu!
Debugger removeSelector: #messageListMenu!
Debugger removeSelector: #shiftedContextStackMenu!
Debugger removeSelector: #shiftedMessageListMenu!
ChangeSorter removeSelector: #browseMethodConflicts!
ChangeSorter removeSelector: #browseMethodConflictsWithOtherSide!
ChangeSorter removeSelector: #changeSetMenu!
ChangeSorter removeSelector: #chooseCngSet!
ChangeSorter removeSelector: #classListMenu!
ChangeSorter removeSelector: #messageListMenu!
ChangeSorter removeSelector: #messageMenu!
ChangeSorter removeSelector: #offerShiftedChangeSetMenu!
ChangeSorter removeSelector: #offerUnshiftedChangeSetMenu!
ChangeSorter removeSelector: #shiftedChangeSetMenu!
ChangeList removeSelector: #browseCurrentVersionsOfSelections!
ChangeList removeSelector: #changeListMenu!
Browser class removeSelector: #openBrowserView:label:!
Browser removeSelector: #addExtraShiftedItemsTo:!
Browser removeSelector: #browseAllClasses!
Browser removeSelector: #classListMenu!
Browser removeSelector: #messageCategoryMenu!
Browser removeSelector: #messageListMenu!
Browser removeSelector: #openSystemCategoryBrowser!
Browser removeSelector: #shiftedClassListMenu!
Browser removeSelector: #shiftedMessageListMenu!
Browser removeSelector: #systemCatSingletonMenu!
Browser removeSelector: #systemCategoryMenu!
CodeProvider removeSelector: #browseAllMessages!
CodeProvider removeSelector: #browseClassVariables!
CodeProvider removeSelector: #browseInstVarDefs!
CodeProvider removeSelector: #browseLocalImplementors!
CodeProvider removeSelector: #browseLocalSendersOfMessages!
CodeProvider removeSelector: #browseProtocol!
CodeProvider removeSelector: #browseUnusedMethods!
CodeProvider removeSelector: #findMethodInChangeSets!
CodeProvider removeSelector: #inspectInstances!
CodeProvider removeSelector: #inspectSubInstances!
CodeProvider removeSelector: #makeSampleInstance!
CodeProvider removeSelector: #offerShiftedClassListMenu!
CodeProvider removeSelector: #offerUnshiftedClassListMenu!
CodeProvider removeSelector: #openMessageListMenu!
CodeProvider removeSelector: #openShiftedMessageListMenu!
CodeProvider removeSelector: #showUnreferencedClassVars!
CodeProvider removeSelector: #showUnreferencedInstVars!
AbstractHierarchicalList removeSelector: #genericMenu!
