'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 2 May 2011 at 1:50:59 pm'!

!DebuggerWindow methodsFor: 'keyboard shortcuts' stamp: 'jmv 5/2/2011 13:50'!
browseClassRefsIn: anInspector

	anInspector selectedClass ifNotNil: [ :cls | 
		Smalltalk browseAllCallsOnClass: cls theNonMetaClass]! !

!DebuggerWindow methodsFor: 'keyboard shortcuts' stamp: 'jmv 5/2/2011 13:50'!
browseFullProtocolIn: anInspector
	"Spawn a window showing full protocol for the receiver's selection"

	MessageSetWindow
		openFullProtocolForClass: anInspector selectedClassOrMetaClass! !

!DebuggerWindow methodsFor: 'keyboard shortcuts' stamp: 'jmv 5/2/2011 13:49'!
browseHierarchyIn: anInspector
	"Create and schedule a class list browser on the receiver's hierarchy."

	HierarchyBrowserWindow
		onClass: anInspector selectedClassOrMetaClass
		selector: nil! !

!DebuggerWindow methodsFor: 'keyboard shortcuts' stamp: 'jmv 5/2/2011 13:47'!
browseMethodFullIn: anInspector
	"Create and schedule a full Browser and then select the current class and message."

	|  myClass |
	(myClass _ anInspector selectedClassOrMetaClass) ifNotNil: [
		BrowserWindow fullOnClass: myClass selector: nil]! !

!DebuggerWindow methodsFor: 'keyboard shortcuts' stamp: 'jmv 5/2/2011 13:48'!
exploreSelectionIn: anInspector
	"Create and schedule an Explorer on the receiver's model's currently selected object."

	^ anInspector selection explore! !

!DebuggerWindow methodsFor: 'keyboard shortcuts' stamp: 'jmv 5/2/2011 13:47'!
inspectSelectionIn: anInspector
	"Create and schedule an Inspector on the receiver's model's currently selected object."

	^ anInspector selection inspect! !

!DebuggerWindow methodsFor: 'keyboard shortcuts' stamp: 'jmv 5/2/2011 11:42'!
inspectorKey: aChar from: view
	"Respond to a Command key issued while the cursor is over my field list"

	aChar == $i ifTrue: [^ self inspectSelectionIn: view model ].
	aChar == $I ifTrue: [^ self exploreSelectionIn: view model ].
	aChar == $b ifTrue:[^ self browseMethodFullIn: view model ].
	aChar == $h ifTrue:[^ self browseHierarchyIn: view model].
	aChar == $p ifTrue: [^ self browseFullProtocolIn: view model].
	aChar == $N ifTrue: [^ self browseClassRefsIn: view model]! !

