'From Cuis 3.3 of 2 June 2011 [latest update: #1024] on 5 June 2011 at 4:22 pm'!

!TIFFStructure methodsFor: 'parsing' stamp: 'jmv 6/3/2011 22:52'!
parseIFDsFrom: aTIFFStream
	"Read as many image file directories as aTIFFStream contains, and put them into my state. Per the TIFF spec, there must be at least one IFD."

	| ifd ifdPosition |
	aTIFFStream position: 4. "Offset in header of pointer to first IFD."
	ifdPosition _ aTIFFStream nextLong.
	[ifdPosition = 0] 
		whileFalse: [
			aTIFFStream position: ifdPosition.
			ifd _ TIFFImageFileDirectory parseFrom: aTIFFStream.
			imageFileDirectories add: ifd.
			ifdPosition _ aTIFFStream nextLong].
! !

