'From Cuis 3.3 of 2 June 2011 [latest update: #1024] on 16 June 2011 at 3:14:54 pm'!

!TextEditor methodsFor: 'private' stamp: 'jmv 6/13/2011 10:10'!
applyAttribute: aTextAttribute
	"The user selected aTextAttribute via shortcut, menu or other means.
	If there is a selection, apply the attribute to the selection.
	In any case use the attribute for the user input (emphasisHere)"
	| interval |

	emphasisHere _ Text addAttribute: aTextAttribute toArray: emphasisHere.
	
	interval _ self selectionInterval.
	(interval isEmpty and: [ aTextAttribute isParagraphAttribute not ])
		ifTrue: [ ^self ].
	
	self text addAttribute: aTextAttribute from: interval first to: interval last.
	paragraph recomposeFrom: interval first to: interval last delta: 0.
	self recomputeSelection.	"Needed so visible selection is updated to reflect new visual extent of selection"
	self userHasEdited.
	morph possiblyChanged! !

