'From Cuis 3.3 of 2 June 2011 [latest update: #1024] on 18 July 2011 at 10:52:26 pm'!

!StrikeFont class methodsFor: 'instance creation' stamp: 'jmv 7/18/2011 22:45'!
create: fontName size: pointSize bold: includeBold italic: includeItalic boldItalic: includeBoldItalic
	
	| base bold oblique boldOblique point prefix |
	prefix _ 'AAFonts', FileDirectory slash, fontName.
	point _ pointSize asString.
	base _ (StrikeFont new
		buildFromForm: (Form fromFileNamed: prefix, '-0-', point, '.bmp')
		data: (FileStream oldFileNamed: prefix, '-0-', point, '.txt') contentsOfEntireFile substrings
		name: fontName, ' ', point)
			pointSize: pointSize.
	includeBold ifTrue: [
		bold _ (StrikeFont new
			buildFromForm: (Form fromFileNamed: prefix, '-1-', point, '.bmp')
			data: (FileStream oldFileNamed: prefix, '-1-', point, '.txt') contentsOfEntireFile substrings
			name: fontName, ' ', point, 'B')
				emphasis: 1;
				pointSize: pointSize.
		base derivativeFont: bold at: 1 ].
	includeItalic ifTrue: [
		oblique _ (StrikeFont new
			buildFromForm: (Form fromFileNamed: prefix, '-2-', point, '.bmp')
			data: (FileStream oldFileNamed: prefix, '-2-', point, '.txt') contentsOfEntireFile substrings
			name: fontName, ' ', point, 'I')
				emphasis: 2;
				pointSize: pointSize.
		base derivativeFont: oblique at: 2].
	includeBoldItalic ifTrue: [
		boldOblique _ (StrikeFont new
			buildFromForm: (Form fromFileNamed: prefix, '-3-', point, '.bmp')
			data: (FileStream oldFileNamed: prefix, '-3-', point, '.txt') contentsOfEntireFile substrings
			name: fontName, ' ', point, 'BI')
				emphasis: 3;
				pointSize: pointSize.
		base derivativeFont: boldOblique at: 3 ].
	
	^base! !

!StrikeFont class methodsFor: 'instance creation' stamp: 'jmv 7/18/2011 22:50'!
installBrushScriptMT
"
StrikeFont installBrushScriptMT
"
	| dejaVuDict |
	dejaVuDict _ Dictionary new.
	(5 to: 24), #(36 48) do: [ :s |
		dejaVuDict at: s put: (self create: 'Brush Script MT' size: s bold: true italic: false boldItalic: false) ].
	AvailableFonts at: 'Brush Script MT' put: dejaVuDict.
	Preferences restoreDefaultFonts! !

!StrikeFont class methodsFor: 'instance creation' stamp: 'jmv 8/21/2009 08:51'!
installDejaVu
"
StrikeFont installDejaVu
"
	| dejaVuDict |
	dejaVuDict _ Dictionary new.
	5 to: 24 do: [ :s |
		dejaVuDict at: s put: (self createDejaVu: s) ].
	AvailableFonts at: 'DejaVu' put: dejaVuDict.
	Preferences restoreDefaultFonts! !

!StrikeFont class methodsFor: 'instance creation' stamp: 'jmv 7/18/2011 22:49'!
installDejaVu2
"
StrikeFont installDejaVu2
"
	| dejaVuDict |
	dejaVuDict _ Dictionary new.
	(5 to: 24) do: [ :s |
		dejaVuDict at: s put: (self create: 'DejaVu Sans' size: s bold: true italic: true boldItalic: true) ].
	AvailableFonts at: 'DejaVu Sans' put: dejaVuDict.
	Preferences restoreDefaultFonts! !

