'From Cuis 3.3 of 2 June 2011 [latest update: #1024] on 3 August 2011 at 10:32:29 am'!

!TextEditor methodsFor: 'private' stamp: 'jmv 8/3/2011 10:31'!
addAttributesForPasting: replacement
	^ (replacement is: #Text)
		ifTrue: [ replacement ]
		ifFalse: [
			Text
				string: replacement
				attributes: emphasisHere ]! !

!TextEditor methodsFor: 'private' stamp: 'jmv 8/3/2011 10:32'!
zapSelectionWith: replacement

	| start stop rep |
	start _ self startIndex.
	stop _ self stopIndex.
	(replacement isEmpty and: [stop > start]) ifTrue: [
		"If deleting, then set emphasisHere from 1st character of the deletion"
		emphasisHere _ (self text attributesAt: start) select: [:att | att mayBeExtended]].

	(start = stop and: [ replacement isEmpty ]) ifFalse: [
		rep _ self addAttributesForPasting: replacement.
		self text replaceFrom: start to: stop - 1 with: rep.
		paragraph
			recomposeFrom: start
			to:  start + rep size - 1
			delta: rep size - (stop-start).
		self markIndex: start pointIndex: start + rep size.
		selectionStartBlocks _ #().
		selectionStopBlocks _ #().
		UndoInterval _ self selectionInterval.
		self userHasEdited  " -- note text now dirty" ].

	morph possiblyChanged! !

