'From Cuis 3.3 of 2 June 2011 [latest update: #1024] on 25 September 2011 at 10:31:33 pm'!
!TextEditorTest methodsFor: 'testing' stamp: 'jmv 9/25/2011 15:14'!
testUndoRedo
	"
	TextEditorTest new testUndoRedo
	"
	| editor model paragraph m text1 text0 text2 |
	text0 _ ''.
	model _ TextModel withText: text0 copy.
	editor _ TextEditor new.
	m _ BareTextMorph new.
	m setEditView: TextModelMorph new.
	editor morph: m.
	editor instVarNamed: 'emphasisHere' put: Array new.
	editor model: model.
	paragraph _ Paragraph new.
	paragraph setModel: model extentForComposing: 300@300.
	editor changeParagraph: paragraph.
	paragraph composeAll.

	text1 _ 'some words' asText.
	editor addString: text1.
	self assert: model actualContents = text1.
	editor undo.
	self assert: model actualContents = text0.
	editor redo.
	self assert: model actualContents = text1.

	text2 _ ' additional inserted stuff' asText.
	editor addString: text2.
	self assert: model actualContents = (text1, text2).
	editor undo.
	self assert: model actualContents = text1.
	editor undo.
	self assert: model actualContents = text0.
	editor redo.
	self assert: model actualContents = text1.
	editor redo.
	self assert: model actualContents = (text1, text2).! !

TextLine removeSelector: #moveBy:!
TextLine removeSelector: #setRight:!
TextLine removeSelector: #slide:!
TextComposer removeSelector: #composeLinesFrom:to:delta:into:priorLines:atY:text:container:!
!classDefinition: #TextComposer category: #'Morphic-Text Support'!
Object subclass: #TextComposer
	instanceVariableNames: 'lines maxRightX currentY scanner possibleSlide nowSliding prevIndex prevLines currCharIndex startCharIndex stopCharIndex deltaCharIndex theText extentForComposing isFirstLine actualHeight anythingComposed editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Text Support'!
Paragraph removeSelector: #adjustRightX!
Paragraph removeSelector: #compositionRectangle!
Paragraph removeSelector: #displayOn:using:at:!
Paragraph removeSelector: #moveBy:!
Paragraph removeSelector: #positionWhenComposed:!
Paragraph removeSelector: #setModel:container:!
!classDefinition: #Paragraph category: #'System-Text'!
Object subclass: #Paragraph
	instanceVariableNames: 'model extentForComposing lines maxRightX selectionStartBlocks selectionStopBlocks focused editor showCaret lastCaretRect lastCaretRectNeedsRedraw'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Text'!
CharacterBlock removeSelector: #moveBy:!
BareTextMorph removeSelector: #container!
BareTextMorph removeSelector: #privateMoveBy:!
BareTextMorph removeSelector: #textBounds!
