'From Cuis 4.0 of 16 November 2011 [latest update: #1144] on 2 December 2011 at 7:40:39 pm'!

!InnerTextMorph methodsFor: 'event handling' stamp: 'jmv 12/2/2011 18:41'!
                       keyboardFocusChange: aBoolean
	
	"The message is sent to a morph when its keyboard focus changes.
	The given argument indicates that the receiver is gaining (versus losing) the keyboard focus.
	In this case, all we need to do is to redraw border feedback"
	paragraph ifNotNil: [ paragraph focused: aBoolean ].
	aBoolean
		ifTrue: [
			"A hand is wanting to send us characters..."
			editor ifNil: [ self editor storeSelectionInParagraph ].	"Forces install"
			self startBlinking ]
		ifFalse: [ self stopBlinking ].
	"Selection might be shown differently when focused"
	owner ifNotNil: [ owner redrawNeeded ].
	self redrawNeeded! !

!InnerTextMorph methodsFor: 'event handling' stamp: 'jmv 12/2/2011 18:55'!
                             mouseMove: evt
	evt mouseButton1Pressed ifFalse: [^ self enterClickableRegion: evt].
	self handleInteraction: [ editor mouseMove: (evt translatedBy: bounds topLeft negated)].
	(evt position y between: owner bounds top and: owner bounds bottom) ifFalse: [
		WorldState addDeferredUIMessage: [
			owner scrollSelectionIntoView: evt ]
	]! !

!InnerTextMorph methodsFor: 'event handling' stamp: 'jmv 12/2/2011 18:56'!
  mouseUp: evt
	super mouseUp: evt.
	self pauseBlinking.
	self handleInteraction: [editor mouseUp: (evt translatedBy: bounds topLeft negated)].
	owner scrollSelectionIntoView: evt! !


!MouseClickState methodsFor: 'actions' stamp: 'jmv 12/2/2011 19:38'!
    clickAndAHalf

	clickAndHalfDone ifFalse: [
		clickAndHalfSelector ifNotNil: [
			"Focus was lost at buttonUp. Set it again."
			lastClickDown hand newMouseFocus: clickClient event: lastClickDown.
			clickClient perform: clickAndHalfSelector with: lastClickDown ].
		clickAndHalfDone _ true ]! !

InnerTextMorph removeSelector: #autoScrollView:!
