'From Cuis 4.0 of 16 November 2011 [latest update: #1144] on 29 December 2011 at 11:25:19 am'!

!TextEditor methodsFor: 'menu messages' stamp: 'jmv 12/29/2011 11:20'!
                         find
	"Prompt the user for a string to search for, and search the receiver from the current selection onward for it.  1/26/96 sw"

	| reply |
	reply _ FillInTheBlank request: 'Find what? ' initialAnswer: FindText.
	"Set focus on our text morph, so that cmd-g does the search again"
	morph world activeHand newKeyboardFocus: morph.
	reply size = 0 ifTrue: [
		^ self].
	self setSearch: reply.
	ChangeText _ FindText.  "Implies no replacement to againOnce: method"
	self findAndReplaceMany: false.

"	morph installEditorToReplace: self"! !


!SmalltalkEditor methodsFor: 'editing keys' stamp: 'jmv 12/29/2011 11:18'!
                         methodStringsContainingit: aKeyboardEvent
	"Triggered by Cmd-E"

	self methodStringsContainingit.
	^ true! !


!SmalltalkEditor class methodsFor: 'keyboard shortcut tables' stamp: 'jmv 12/29/2011 11:17'!
                    initializeCmdKeyShortcuts
	"Initialize the (unshifted) command-key (or alt-key if not on Mac) shortcut table."
	"NOTE: if you don't know what your keyboard generates, use Sensor test"
	"SmalltalkEditor initialize"

	| cmds |
	self initializeBasicCmdKeyShortcuts.
	
	cmds := #(
		$i	#inspectIt:
		$p	#printIt:

		$s	#save:
		$d	#doIt:
		$l	#cancel:

		$b	#browseIt:
		$n	#sendersOfIt:
		$m	#implementorsOfIt:

		$E	#methodStringsContainingit:
		$T	#displayIfTrue:
		$I	#exploreIt:

		$A	#argAdvance:
		$F	#displayIfFalse:
		$G	#fileItIn:

		$V	#pasteInitials:
		$N	#referencesToIt:
	).
	1 to: cmds size
		by: 2
		do: [ :i | cmdActions at: (cmds at: i) asciiValue + 1 put: (cmds at: i + 1)]! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."
Editor initialize!

