'From Cuis 2.7 of 3 September 2010 [latest update: #600] on 27 September 2010 at 2:01:15 pm'!

!ChangeRecord methodsFor: 'initialization' stamp: 'jmv 9/27/2010 14:00'!
fileIn
	"File the receiver in.  If I represent a method or a class-comment, file the method in and make a note of it in the recent-submissions list; if I represent a do-it, then, well, do it."
	Cursor read showWhile: [ | s |
		type == #method ifTrue: [
			self methodClass ifNotNil: [ :methodClass |
				methodClass
					compile: self text
					classified: category
					withStamp: stamp
					notifying: nil.
				self methodSelector ifNotNil: [ :aSelector |
					Utilities
						noteMethodSubmission: aSelector
						forClass: methodClass ]]].
		type == #doIt ifTrue: [
			((s _ self string) beginsWith: '----') ifFalse: [ Smalltalk actualCompilerClass evaluate: s ]].
		type == #classDefinition ifTrue: [ Smalltalk actualCompilerClass evaluate: self string ].
		type == #classComment ifTrue: [ | cls |
			(cls _ Smalltalk at: class asSymbol)
				comment: self text
				stamp: stamp.
			Utilities
				noteMethodSubmission: #Comment
				forClass: cls ]].! !

