'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 25 November 2010 at 3:50:36 pm'!

!Utilities class methodsFor: 'common requests' stamp: 'jmv 11/25/2010 10:34'!
initializeCommonRequestStrings
	"Initialize the common request strings, a directly-editable list of expressions that can be evaluated from the 'do...' menu."

	CommonRequestStrings _ TextHolder new actualContents: 
'Utilities saveScreenshot.
Utilities saveDisplay.
Cursor normal show.
Transcript clear.
-
Undeclared inspect.
Undeclared removeUnreferencedKeys; inspect.
-
ChangeSorter removeEmptyUnnamedChangeSets.
ChangeSorter reorderChangeSets.'

"Utilities initializeCommonRequestStrings"! !

!Utilities class methodsFor: 'common requests' stamp: 'jmv 11/25/2010 10:34'!
offerCommonRequestsInMorphic
	"Offer up the common-requests menu.  If the user chooses one, then evaluate it, and -- provided the value is a number or string -- show it in the Transcript."

	"Utilities offerCommonRequests"

	| aMenu strings aString |
	(CommonRequestStrings == nil or: [CommonRequestStrings isKindOf: Array]) 
		ifTrue: [self initializeCommonRequestStrings].
	strings := CommonRequestStrings actualContents.
	aMenu := MenuMorph new.
	aMenu title: 'Common Requests' translated.
	aMenu addStayUpIcons.
	strings asString linesDo: [ :each | 
		aString _ each.
		aString = '-' 
			ifTrue: [ aMenu addLine ]
			ifFalse: [
				aString size = 0 ifTrue: [ aString := ' ' ].
				aMenu 
					add: aString
					target: self
					selector: #eval:
					argument: aString]].
	aMenu addLine.
	aMenu 
		add: 'edit this list' translated
		target: self
		action: #editCommonRequestStrings.
	aMenu popUpInWorld: self currentWorld! !

