'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 7 December 2010 at 2:40:06 pm'!
"Change Set:		0703-MakeSoftThemeDefault-cbr
Date:			7 December 2010
Author:			Casey Ransberger
"
Theme beCurrent!

!classDefinition: #ClassicTheme category: #'Theme-Themes'!
Theme subclass: #ClassicTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Theme-Themes'!

!ClassicTheme commentStamp: 'cbr 12/6/2010 20:11' prior: 0!
This is the theme from Cuis 2.9.!


!Browser methodsFor: 'class functions' stamp: 'jmv 12/7/2010 14:38'!
buildMorphicSwitches
	| instanceSwitch commentSwitch classSwitch row buttonColor |
	instanceSwitch := PluggableButtonMorph 
				model: self
				stateGetter: #instanceMessagesIndicated
				action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		borderWidth: 0.
	commentSwitch := PluggableButtonMorph 
				model: self
				stateGetter: #classCommentIndicated
				action: #plusButtonHit.
	commentSwitch
		label: '?' asText allBold;
		setBalloonText: 'class comment';
		borderWidth: 0.
	classSwitch := PluggableButtonMorph 
				model: self
				stateGetter: #classMessagesIndicated
				action: #indicateClassMessages.
	classSwitch
		label: 'class';
		borderWidth: 0.
	row _ AlignmentMorph proportional.
	row
		addMorph: instanceSwitch fullFrame: (LayoutFrame fractions: (0@0 corner: 0.45@1));
		addMorph: commentSwitch fullFrame: (LayoutFrame fractions: (0.45@0 corner: 0.67@1));
		addMorph: classSwitch fullFrame: (LayoutFrame fractions: (0.67@0 corner: 1@1)).
	buttonColor _ Theme current buttonColorFrom: self class windowColor.
	row color: buttonColor.
	{ 
		instanceSwitch.
		commentSwitch.
		classSwitch} do: [:m | 
				m color: buttonColor ].
	^row! !


!Theme methodsFor: 'colors' stamp: 'cbr 12/6/2010 19:58'!
buttonLabel
	^Color gray: 0.25! !

!Theme methodsFor: 'colors' stamp: 'cbr 12/6/2010 20:08'!
windowLabel
	^Color gray: 0.3! !

!Theme methodsFor: 'other options' stamp: 'cbr 12/6/2010 20:02'!
embossedTitles
	^true! !

!Theme methodsFor: 'other options' stamp: 'cbr 12/6/2010 20:03'!
roundButtons
	^true! !

!Theme methodsFor: 'other options' stamp: 'jmv 12/7/2010 14:32'!
roundWindowCorners
	^true! !

!Theme methodsFor: 'other options' stamp: 'cbr 12/6/2010 20:07'!
useButtonGradient
	^true! !

!Theme methodsFor: 'other options' stamp: 'cbr 12/6/2010 20:08'!
useWindowTitleGradient
	^true! !


!ClassicTheme methodsFor: 'colors' stamp: 'cbr 12/6/2010 19:44'!
buttonLabel
	^ Color black! !

!ClassicTheme methodsFor: 'other options' stamp: 'cbr 12/6/2010 19:44'!
embossedTitles
	^false! !

!ClassicTheme methodsFor: 'other options' stamp: 'cbr 12/6/2010 19:44'!
roundButtons
	^false! !

!ClassicTheme methodsFor: 'other options' stamp: 'cbr 12/6/2010 19:53'!
roundWindowCorners
	^false! !

!ClassicTheme methodsFor: 'other options' stamp: 'cbr 12/6/2010 19:44'!
useButtonGradient
	^false! !

!ClassicTheme methodsFor: 'other options' stamp: 'cbr 12/6/2010 19:44'!
useWindowTitleGradient
	^false! !

!ClassicTheme methodsFor: 'other options' stamp: 'cbr 12/6/2010 19:56'!
windowLabel
	^Color black! !

Smalltalk removeClassNamed: #SoftTheme!
