'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 14 December 2010 at 2:12:04 am'!
"Change Set:		MoveCurrentPaletteToCurrentTheme-cbr
Date:			14 December 2010
Author:			Casey Ransberger

Get rid of the last reference to Palette."

!

!classDefinition: #Theme category: #'Theme-Core'!
Object subclass: #Theme
	instanceVariableNames: ''
	classVariableNames: 'CurrentPalette CurrentTheme '
	poolDictionaries: ''
	category: 'Theme-Core'!

!Theme commentStamp: '<historical>' prior: 0!
Themes are collections of methods that affect the way the system presents itself. They can be used to change the color scheme, as well as to modify other look and feel properties (e.g., round versus square window corners, embossed versus solid window labels.)

Theme serves as base theme. You can make new themes by subclassing it, and you can see what's possible by browsing its methods.!


!Theme class methodsFor: 'as yet unclassified' stamp: 'cbr 12/14/2010 01:55'!
beCurrent
	^ self currentTheme: self! !

!Theme class methodsFor: 'as yet unclassified' stamp: 'cbr 12/14/2010 01:53'!
currentTheme: aTheme
	CurrentTheme := aTheme new.
	SHTextStylerST80 initialize.
	World color: CurrentTheme background.
	ThreePhaseButtonMorph initialize.
	SystemWindow initialize.
	PluggableButtonMorph initialize.
	World restoreMorphicDisplay.
	
	^ CurrentTheme! !


!Theme class reorganize!
('as yet unclassified' beCurrent current currentTheme:)
!

"Postscript:
Copy the reference from CurrentPalette to new class variable CurrentTheme."

Theme currentTheme: Theme.!

