'From Cuis 3.0 of 18 January 2011 [latest update: #768] on 26 January 2011 at 1:06:56 pm'!

!Clipboard methodsFor: 'accessing' stamp: 'jmv 1/26/2011 10:37'!
retrieveObject
	"Answer whatever was last stored in the clipboard"
	| stringOrNil |

	"If the OS clipboard has the id for our contents, or the same characters, then answer the richer Smalltalk object."
	stringOrNil _ self retrieveIdOrStringFromOS.
	(stringOrNil = (self idFor: contents) or: [ stringOrNil = contents asString])
		ifTrue: [
			"We copy the object, because the result of each paste operation could be modified independently of the others afterwards
			(and the same clipboard contents might be pasted many times)"
			^contents copyForClipboard ].

	"If we have the ExtendedClipboardInterface, try to get an RTF or Form"
	Smalltalk at: #ExtendedClipboardInterface ifPresent: [ :clipboardInterface |
		clipboardInterface current retrieveObject ifNotNil: [ :object | ^object ]].

	"Otherwise answer the string brought by clipboard primitives"
	^stringOrNil! !

