'From Cuis 3.0 of 31 January 2011 [latest update: #790] on 18 February 2011 at 6:53:56 pm'!

!MenuItemMorph methodsFor: 'events' stamp: 'jmv 2/18/2011 18:48'!
mouseUp: evt
	"Handle a mouse up event. Menu items get activated when the mouse is over them. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."
	evt hand mouseFocus == owner ifFalse:[^self].
	"This will happen if the menu has toggles in it. (for instance, the 'show...' button)
	Update the look, refresh the world and wait a bit,
	to give the user some visual feedback"
	self contentString ifNotNil: [
		self contents: self contentString withMarkers: true inverse: true.
		self refreshWorld.
		(Delay forMilliseconds: 200) wait].
	self deselect: evt.
	self invokeWithEvent: evt.		
! !


!SimpleButtonMorph methodsFor: 'event handling' stamp: 'jmv 2/18/2011 18:52'!
mouseDown: evt

	| now dt |
	super mouseDown: evt.
	now _ Time millisecondClockValue.
	oldColor _ self fillStyle. 
	actWhen == #buttonDown
		ifTrue: [ self doButtonAction ]
		ifFalse: [
			"Not very pretty implementation of button pressed visual feedback...
			PluggableButtonMorph seems to be nicer...
			Sometime, merge those 2 classes"
			self updateVisualState: evt; refreshWorld ].
	dt _ Time millisecondClockValue - now max: 0.  "Time it took to do"
	dt < 200 ifTrue: [(Delay forMilliseconds: 200-dt) wait].
	self mouseStillDown: evt.! !

