'From Cuis 3.0 of 18 January 2011 [latest update: #768] on 28 February 2011 at 3:44:51 pm'!

!Object methodsFor: 'testing' stamp: 'jmv 2/28/2011 15:43'!
is: aSymbol
	"A means for cleanly replacing isXXX like methods.
	Please use judiciously!!
	Suggested by Igor Stasenko at
	http://lists.squeakfoundation.org/pipermail/squeak-dev/2009-June/136793.html
	aSymbol is ussually a class name (starting with uppercase) or a protocolo conformance question (starting with lowercase), such as #hasTextSelector, #hasTextProvider, etc.
	
	A few comments:
	
		- Good for kernel tests
		- Good for tests defined in the same package as the receiver
		- Overwriting this method in a different package is a bad idea. It will surely conflict with other package. Use the traditional isXXX in such cases
		
		- In any case, asking these kinds of questions is a sign of poor design. If possible, avoid the question altogether, using, for example, double dispatching.
		
		- if a class happens to answer true for several Symbols, consider implementing it like:
			^#(symbol1 symbol2 symbol3) pointsTo: aSymbol
		"
	
	"Enable this to log improper calls to the Transcript..."
	"
	aSymbol class == Symbol ifFalse: [ thisContext sender sender print. aSymbol print ].
	"
	^false! !


!CodeProvider methodsFor: 'testing' stamp: 'jmv 2/28/2011 15:44'!
is: aSymbol
	^(#(CodeProvider #ShoutEnabled) pointsTo: aSymbol)
		or: [ super is: aSymbol ]! !

