'From Cuis 3.1 of 4 March 2011 [latest update: #850] on 17 March 2011 at 8:19:54 am'!

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 3/17/2011 08:19'!
createQueryTextMorph: queryString 
	"create the queryTextMorph"
	| result |
	result := StringMorph new contents: queryString.
	result lock.
	result bounds: ( 30@7 corner: 269@22).
	self addMorph: result.
	^ result! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 3/17/2011 08:19'!
createTextPaneExtent: answerExtent acceptBoolean: acceptBoolean
	"create the textPane"
	| result |
	result := TextModelMorph
				textProvider: self
				textGetter: #response
				textSetter: #response:
				selectionGetter: #selectionInterval.
	result extent: answerExtent.
	result borderWidth: 1; borderColor: Color lightGray.
	result hasUnacceptedEdits: true.
	result acceptOnCR: acceptBoolean.
	result bounds: (14@25 corner: 257@84).
	self addMorph: result.
	^ result! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 3/17/2011 08:06'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Theme current menu! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'jmv 3/17/2011 08:06'!
initialize

	super initialize.
	self extent: 271@121.
	responseUponCancel := ''
	! !

!FillInTheBlankMorph methodsFor: 'drawing' stamp: 'jmv 3/17/2011 08:08'!
drawOn: aCanvas
	| roundCorners |
	roundCorners _ Theme current roundWindowCorners.
	roundCorners
		ifTrue: [
			aCanvas roundRect: bounds color: self fillStyle radius: Theme current roundedWindowRadius ]
		ifFalse: [
			super drawOn: aCanvas ].
	aCanvas fillRectangle: textPane bounds fillStyle: (Color gray: 0.88)! !


!Theme methodsFor: 'menu colors' stamp: 'jmv 3/17/2011 08:05'!
menu
	Display depth <= 2 ifTrue: [^ Color white].
	^Color r: 0.75 g: 0.75 b: 0.75 alpha: 0.9! !

FillInTheBlankMorph removeSelector: #setDefaultParameters!
