'From Cuis 3.1 of 4 March 2011 [latest update: #850] on 4 April 2011 at 5:39:36 pm'!

!Clipboard methodsFor: 'private' stamp: 'jmv 4/4/2011 17:34'!
retrieveIdOrStringFromOS
	"Use a specific content type if ExtendedClipboard is active.
	Otherwise, use regular clipboard primitives"
	| primitiveFormat interface |

	Smalltalk at: #ExtendedClipboardInterface ifPresent: [ :clipboardInterface |
		interface _ clipboardInterface current.
		interface canStore ifTrue: [
			"Answer nil if no id was stored"
			^ clipboardInterface current retrieveId ]].
		
	primitiveFormat _ self primitiveClipboardString.

	"Clipboard primitives answer an empty string if there is no string in OS clipboard.
	We prefer nil"
	primitiveFormat isEmpty ifTrue: [ ^nil ].

	"The VM uses UTF-8 for clipboard"
	^primitiveFormat utf8ToISO8859s15 withSqueakLineEndings! !

