'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 19 April 2011 at 6:26:11 pm'!

!Morph methodsFor: 'menus' stamp: 'cbr 4/19/2011 00:41'!
collapse
	"Since we don't have an iconified representation of regular morphs,
	we show the taskbar when they are minimized."
	
	Taskbar show.
	Taskbar minimize: self! !

!Morph methodsFor: 'menus' stamp: 'cbr 4/19/2011 00:55'!
expand
	
	self comeToFront.
	Taskbar restore: self! !


!SystemWindow methodsFor: 'resize/collapse' stamp: 'cbr 4/18/2011 21:49'!
collapse

	| cf |
		
	self isCollapsed ifFalse: [

		"Collapse -- remove panes from morphics structure"

		isCollapsed _ true.
		fullFrame _ bounds.

		"First save latest fullFrame"
		layoutMorph ifNotNil: [ layoutMorph hide ].
		cf := self getCollapsedFrame.
		(collapsedFrame isNil and: [Preferences collapseWindowsInPlace not])
			ifTrue: [collapsedFrame _ cf].

		self bounds: cf.
	
		Taskbar visible ifTrue: [ Taskbar minimize: self ]
	]! !

!SystemWindow methodsFor: 'resize/collapse' stamp: 'cbr 4/19/2011 02:02'!
expand
	self isCollapsed
		ifTrue: [
		
			"Expand -- restore panes to morphics structure"
	
			isCollapsed _ false.
			self activate.  "Bring to front first"

			Preferences collapseWindowsInPlace
				ifTrue: [ fullFrame := fullFrame align: fullFrame topLeft with: bounds topLeft]
				ifFalse: [ collapsedFrame _ bounds].

			self bounds: fullFrame.
			layoutMorph ifNotNil: [ layoutMorph show ].
			
			Taskbar visible ifTrue: [ Taskbar restore: self. ]
		]! !


!TheWorldMenu methodsFor: 'construction' stamp: 'cbr 4/19/2011 01:12'!
appearanceMenu
	"Build the appearance menu for the world."
	
	^self fillIn: (self menu: 'appearance...') from: {
		{'show taskbar' . {Taskbar . #show} . 'show the taskbar'}.
		{'hide taskbar' . {Taskbar . #hide} . 'hide the taskbar'}.
		nil.
		{'system fonts...' . { self . #standardFontDo} . 'Choose the standard fonts to use for code, lists, menus, window titles, etc.'}.
		nil.
		{'full screen on' . { self . #fullScreenOn} . 'puts you in full-screen mode, if not already there.'}.
		{'full screen off' . { self . #fullScreenOff} . 'if in full-screen mode, takes you out of it.'}.
		nil.
		{'set display depth...' . {self. #setDisplayDepth} . 'choose how many bits per pixel.'}.
		{'set desktop color...' . {self. #changeBackgroundColor} . 'choose a uniform color to use as desktop background.'}.
	}! !

