'From Cuis 3.3 of 2 June 2011 [latest update: #1024] on 3 November 2011 at 4:22:19 pm'!

!MigratingSourceFileArray commentStamp: '<historical>' prior: 0!
To aid in migrating from one kind of SourceFileArray to another one. For example:

1) Check (and adjust if needed) the value for pointerScale in CuisSourceFileArray>>initialize

2) Correct (if needed) SystemDictionary>>openSourceFiles, to create an instance of CuisSourceFileArray

3) Evaluate:
	| migrating |
	migrating _ MigratingSourceFileArray new.
	migrating reader: SourceFiles writer: CuisSourceFileArray new.
	SourceFiles _ migrating.
	Smalltalk condenseSources

After this, the new Sources file will be saved according to CuisSourceFileArray. After saving the image, when the image starts it will set up a new CuisSourceFileArray, and it is possible to remove any other subclass of SourceFileArray (such as MigratingSourceFileArray and StandardSourceFileArray) if desired.!


!SystemDictionary methodsFor: 'sources, change log' stamp: 'jmv 11/3/2011 16:22'!
openSourceFiles
	self imageName = LastImageName ifFalse: [
		"Reset the author initials to blank when the image gets moved"
		LastImageName _ self imageName.
		Utilities setAuthorInitials: ''].
	"Warning: Do open the source files only if nil.
	If not nil, it is because they are internalized and the files should not be opened"
	FileDirectory
		openSources: self defaultSourcesName
		andChanges: self localChangesName
		forImage: LastImageName.
	CuisSourceFileArray install! !

