'From Cuis 4.0 of 16 November 2011 [latest update: #1144] on 2 December 2011 at 2:17:16 pm'!

!ContextPart methodsFor: 'controlling' stamp: 'ar 12/2/2011 17:10'!
                              resume: value
	"Unwind thisContext to self and resume with value as result of last send.  Execute unwind blocks when unwinding.  ASSUMES self is a sender of thisContext"

	| ctxt unwindBlock oldSndr |
	self isDead ifTrue: [self cannotReturn: value to: self].
	ctxt := thisContext.
	[	ctxt := ctxt findNextUnwindContextUpTo: self.
		ctxt isNil
	] whileFalse: [
		(ctxt tempAt: 2) ifNil:[
			ctxt tempAt: 2 put: true.
			unwindBlock := ctxt tempAt: 1.
			"Prevent returning from unwind block"
			oldSndr := unwindBlock home swapSender: nil.
			thisContext terminateTo: ctxt.
			unwindBlock value.
			unwindBlock home swapSender: oldSndr.
		].
	].
	thisContext terminateTo: self.
	^ value
! !

